#define joystick_exists
// joystick_exists(id)
//Just like the GM function, returns true if the given joystick exists.
return (joy_count() >= argument0);
#define joystick_name
// joystick_name(id)
//Just like the GM function, returns the given joystick's name.
//  (unlike the GM function, returns the *actual* joystick name)
return joy_name(joy_gmid(argument0));
#define joystick_axes
// joystick_axes(id)
//Just like the GM function, returns the number of axes on the joystick.
return joy_axes(joy_gmid(argument0));
#define joystick_buttons
// joystick_buttons(id)
//Just like the GM function, returns the number of buttons on the joystick.
return joy_buttons(joy_gmid(argument0));
#define joystick_has_pov
// joystick_has_pov(id)
//Just like the GM function, returns true if the joystick has a POV hat (D-pad).
return (joy_hats(joy_gmid(argument0)) > 0);
#define joystick_direction
// joystick_direction(id)
//Just like the GM function, returns a numpad keycode corresponding to
//    the direction of the joystick's X and Y axes.

//(I had to guess how Game Maker does this, so there's a subtle difference...)
var jx, jy, res;
jx = joy_x(joy_gmid(argument0));
jy = joy_y(joy_gmid(argument0));
res = vk_numpad1;
if (jy < -.4) {res += 6;}
else if (jy < .4) {res += 3;}
if (jx > .4) {res += 2;}
else if (jx > -.4) {res += 1;}
return res;
#define joystick_check_button
// joystick_check_button(id, button)
//Just like the GM function, returns true when the button is down.
return joy_button(joy_gmid(argument0), argument1);
#define joystick_xpos
// joystick_xpos(id)
//Just like the GM function, returns the first axis value of the joystick.
return joy_x(joy_gmid(argument0));
#define joystick_ypos
// joystick_ypos(id)
//Just like the GM function, returns the second axis value of the joystick.
return joy_y(joy_gmid(argument0));
#define joystick_zpos
// joystick_zpos(id)
//Just like the GM function, returns the third axis value of the joystick.
return joy_z(joy_gmid(argument0));
#define joystick_rpos
// joystick_rpos(id)
//Just like the GM function, returns the fourth axis value of the joystick.
return joy_r(joy_gmid(argument0));
#define joystick_upos
// joystick_upos(id)
//Just like the GM function, returns the fifth axis value of the joystick.
return joy_u(joy_gmid(argument0));
#define joystick_vpos
// joystick_vpos(id)
//Just like the GM function, returns the sixth axis value of the joystick.
return joy_v(joy_gmid(argument0));
#define joystick_pov
// joystick_pov(id)
//Just like the GM function, returns -1 for centered or an eigth-circle angle.
//  (Angles go clockwise starting with 0 as up, around to 315 as up-left)
return joy_hat(joy_gmid(argument0));
#define joy_gmid
//Used internally to imitate Game Maker's handling of joystick IDs.
return max(argument0-1, 0);
